void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void AND2_init__(AND2 *data__, BOOL retain) {
  __INIT_LOCATED(BOOL,__IX0_0,data__->S0,retain)
  __INIT_LOCATED_VALUE(data__->S0,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_1,data__->S1,retain)
  __INIT_LOCATED_VALUE(data__->S1,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_2,data__->S2,retain)
  __INIT_LOCATED_VALUE(data__->S2,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_3,data__->S3,retain)
  __INIT_LOCATED_VALUE(data__->S3,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_4,data__->S4,retain)
  __INIT_LOCATED_VALUE(data__->S4,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_5,data__->S5,retain)
  __INIT_LOCATED_VALUE(data__->S5,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_6,data__->S6,retain)
  __INIT_LOCATED_VALUE(data__->S6,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX0_7,data__->S7,retain)
  __INIT_LOCATED_VALUE(data__->S7,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__IX1_0,data__->S8,retain)
  __INIT_LOCATED_VALUE(data__->S8,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_0,data__->L0,retain)
  __INIT_LOCATED_VALUE(data__->L0,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_1,data__->L1,retain)
  __INIT_LOCATED_VALUE(data__->L1,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_2,data__->L2,retain)
  __INIT_LOCATED_VALUE(data__->L2,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_3,data__->L3,retain)
  __INIT_LOCATED_VALUE(data__->L3,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_4,data__->L4,retain)
  __INIT_LOCATED_VALUE(data__->L4,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_5,data__->L5,retain)
  __INIT_LOCATED_VALUE(data__->L5,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_6,data__->L6,retain)
  __INIT_LOCATED_VALUE(data__->L6,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX0_7,data__->L7,retain)
  __INIT_LOCATED_VALUE(data__->L7,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX1_0,data__->L8,retain)
  __INIT_LOCATED_VALUE(data__->L8,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX1_1,data__->L9,retain)
  __INIT_LOCATED_VALUE(data__->L9,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX2_0,data__->M0,retain)
  __INIT_LOCATED_VALUE(data__->M0,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX2_1,data__->M1,retain)
  __INIT_LOCATED_VALUE(data__->M1,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX2_2,data__->M2,retain)
  __INIT_LOCATED_VALUE(data__->M2,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX2_3,data__->M3,retain)
  __INIT_LOCATED_VALUE(data__->M3,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX2_4,data__->M4,retain)
  __INIT_LOCATED_VALUE(data__->M4,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX2_5,data__->M5,retain)
  __INIT_LOCATED_VALUE(data__->M5,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX2_6,data__->M6,retain)
  __INIT_LOCATED_VALUE(data__->M6,__BOOL_LITERAL(FALSE))
  __INIT_LOCATED(BOOL,__QX2_7,data__->M7,retain)
  __INIT_LOCATED_VALUE(data__->M7,__BOOL_LITERAL(FALSE))
}

// Code part
void AND2_body__(AND2 *data__) {
  // Initialise TEMP variables

  __SET_LOCATED(data__->,M0,,(__GET_LOCATED(data__->S1,) && __GET_LOCATED(data__->S0,)));
  __SET_LOCATED(data__->,M1,,((__GET_LOCATED(data__->S4,) && __GET_LOCATED(data__->S3,)) && __GET_LOCATED(data__->S2,)));
  __SET_LOCATED(data__->,L0,,(__GET_LOCATED(data__->M1,) && __GET_LOCATED(data__->M0,)));

  goto __end;

__end:
  return;
} // AND2_body__() 





